;;; -*-  Lisp -*-

(defpackage :net-telent-date-system (:use #:cl #:asdf))
(in-package :net-telent-date-system)

(defsystem net-telent-date
    :version "0.1"
    :components ((:file "defpackage")
		 (:file "date" :depends-on ("defpackage"))
		 (:file "parse-time" :depends-on ("defpackage"))
		 (:static-file "README")
		 (:static-file "tests" :pathname "tests.lisp")))
    
(defun mapappend (function list)
  (let ((f (coerce function 'function)))
    (loop for i in list append (funcall f i))))

(defgeneric list-files (component))
(defmethod list-files ((c source-file))
  (list (component-pathname c)))
(defmethod list-files ((c module))
  (mapappend 'list-files (module-components c)))


(defun make-tar-file (system)
  (let* ((system (find-system system))
	 (sys-path  (component-pathname system))
	 (base-path (make-pathname
		     :directory (butlast (pathname-directory sys-path))
		     :defaults sys-path))
	 (files
	  (mapcar (lambda (x) (enough-namestring x base-path))
		  (cons
		   (truename (system-definition-pathname system))
		   (list-files system)))))
    (= 0
       (run-shell-command "cd ~A && tar zcf ~A_~A.tar.gz  ~{~D ~}"
			  (namestring base-path)
			  (component-name system)
			  (component-version system)			  
			  files))))
